/*
 *  H8 Simple Monitor
 * 
 *  Copyright (C) 1999-2004 by Dep. of Computer Science and Engineering
 *                   Tomakomai National College of Technology, JAPAN
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: $
 */

#ifndef _3052_H_
#define _3052_H_

/*
 *	3052.h -- definitions for H8/3052F 
 */

/*	Values	*/

#define TARGET_CPU_STR		"3052F"
#define CLOCK_RATE		25000000

/*	Address		*/

#define ROM_BASE		0x000000
#define ROM_SIZE		0x080000
#define RAM_BASE		0xffdf10
#define RAM_SIZE		0x002000
#define VECTOR_BASE		ROM_BASE
#define VECTOR_SIZE		0x100

/*	Vector Address	*/

#define VEC_RESET		0x000000
#define VEC_IMIA0		0x000060		/* ITU #0, IM/IC A */
#define VEC_IMIA1		0x000070		/* ITU #1, IM/IC A */
#define VEC_IMIA2		0x000080		/* ITU #1, IM/IC A */
#define VEC_SCI0		0x0000d0		/* SCI #0 */
#define VEC_SCI1		0x0000e0		/* SCI #1 */

/*	 Condition Code Register */

#define CCR_INTERRUPT		0x80
#define CCR_USER_INTER		0x40
#define CCR_HALF_CARRY		0x20
#define CCR_USER		0x10
#define CCR_NEGATIVE		0x08
#define CCR_ZERO		0x04
#define CCR_OVERFLOW		0x02
#define CCR_CARRY		0x01

/*	Serial Channels		*/

#define MAX_SERIAL		2
#define IOREG_SCI_BASE		0xffffb0
#define IOREG_SMR_OFFSET	0x0
#define IOREG_BRR_OFFSET	0x1
#define IOREG_SCR_OFFSET	0x2
#define IOREG_TDR_OFFSET	0x3
#define IOREG_SSR_OFFSET	0x4
#define IOREG_RDR_OFFSET	0x5

/*	Status bits in SSR	*/

#define SSR_TDRE		0x80
#define SSR_RDRF		0x40
#define SSR_OPER		0x20
#define SSR_FER			0x10
#define SSR_PER			0x08

/*	Status bits in SCR	*/

#define SCR_TIE			0x80
#define SCR_RIE			0x40
#define SCR_TE			0x20
#define SCR_RE			0x10

/*	Palarel Ports		*/

#define IOREG_PPBASE		0xffff00

#define IOREG_P1DDR		0xffffc0
#define IOREG_P2DDR		0xffffc1
#define IOREG_P3DDR		0xffffc4
#define IOREG_P4DDR		0xffffc5
#define IOREG_P5DDR		0xffffc8
#define IOREG_P6DDR		0xffffc9
#define IOREG_P8DDR		0xffffcd
#define IOREG_P9DDR		0xffffd0
#define IOREG_PADDR		0xffffd1
#define IOREG_PBDDR		0xffffd4

#define IOREG_P1DR		0xffffc2
#define IOREG_P2DR		0xffffc3
#define IOREG_P3DR		0xffffc6
#define IOREG_P4DR		0xffffc7
#define IOREG_P5DR		0xffffca
#define IOREG_P6DR		0xffffcb
#define IOREG_P8DR		0xffffcf
#define IOREG_P9DR		0xffffd2
#define IOREG_PADR		0xffffd3
#define IOREG_PBDR		0xffffd6

#define IOREG_P2PCR		0xffffd8
#define IOREG_P4PCR		0xffffda
#define IOREG_P6PCR		0xffffdb

/*	Integrated Timer Unit, Common Register	*/

#define IOREG_TSTR		0xffff60
#define IOREG_TSNC		0xffff61
#define IOREG_TMDR		0xffff62
#define IOREG_TFCR		0xffff63
#define IOREG_TOER		0xffff90
#define IOREG_TOCR		0xffff91

/*	Integrated Timer Unit, Channel #0	*/

#define IOREG_TCR0		0xffff64
#define IOREG_TIOR0		0xffff65
#define IOREG_TIER0		0xffff66
#define IOREG_TSR0		0xffff67
#define IOREG_TCNT0		0xffff68
#define IOREG_TCNT0H		0xffff68
#define IOREG_TCNT0L		0xffff69
#define IOREG_GRA0		0xffff6a
#define IOREG_GRA0H		0xffff6a
#define IOREG_GRA0L		0xffff6b
#define IOREG_GRB0		0xffff6c
#define IOREG_GRB0H		0xffff6c
#define IOREG_GRB0L		0xffff6d

/*	Integrated Timer Unit, Channel #1	*/

#define IOREG_TCR1		0xffff6e
#define IOREG_TIOR1		0xffff6f
#define IOREG_TIER1		0xffff70
#define IOREG_TSR1		0xffff71
#define IOREG_TCNT1		0xffff72
#define IOREG_TCNT1H		0xffff72
#define IOREG_TCNT1L		0xffff73
#define IOREG_GRA1		0xffff74
#define IOREG_GRA1H		0xffff74
#define IOREG_GRA1L		0xffff75
#define IOREG_GRB1		0xffff76
#define IOREG_GRB1H		0xffff76
#define IOREG_GRB1L		0xffff77

/*	Integrated Timer Unit, Channel #2	*/

#define IOREG_TCR2		0xffff78
#define IOREG_TIOR2		0xffff79
#define IOREG_TIER2		0xffff7a
#define IOREG_TSR2		0xffff7b
#define IOREG_TCNT2		0xffff7c
#define IOREG_TCNT2H		0xffff7c
#define IOREG_TCNT2L		0xffff7d
#define IOREG_GRA2		0xffff7e
#define IOREG_GRA2H		0xffff7e
#define IOREG_GRA2L		0xffff7f
#define IOREG_GRB2		0xffff80
#define IOREG_GRB2H		0xffff80
#define IOREG_GRB2L		0xffff81

/*	Integrated Timer Unit, Channel #3	*/

#define IOREG_TCR3		0xffff82
#define IOREG_TIOR3		0xffff83
#define IOREG_TIER3		0xffff84
#define IOREG_TSR3		0xffff85
#define IOREG_TCNT3		0xffff86
#define IOREG_TCNT3H		0xffff86
#define IOREG_TCNT3L		0xffff87
#define IOREG_GRA3		0xffff88
#define IOREG_GRA3H		0xffff88
#define IOREG_GRA3L		0xffff89
#define IOREG_GRB3		0xffff8a
#define IOREG_GRB3H		0xffff8a
#define IOREG_GRB3L		0xffff8b
#define IOREG_BRA3		0xffff8c
#define IOREG_BRA3H		0xffff8c
#define IOREG_BRA3L		0xffff8d
#define IOREG_BRB3		0xffff8e
#define IOREG_BRB3H		0xffff8e
#define IOREG_BRB3L		0xffff8f

/*	Integrated Timer Unit, Channel #4	*/

#define IOREG_TCR4		0xffff92
#define IOREG_TIOR4		0xffff93
#define IOREG_TIER4		0xffff94
#define IOREG_TSR4		0xffff95
#define IOREG_TCNT4		0xffff96
#define IOREG_TCNT4H		0xffff96
#define IOREG_TCNT4L		0xffff97
#define IOREG_GRA4		0xffff98
#define IOREG_GRA4H		0xffff98
#define IOREG_GRA4L		0xffff99
#define IOREG_GRB4		0xffff9a
#define IOREG_GRB4H		0xffff9a
#define IOREG_GRB4L		0xffff9b
#define IOREG_BRA4		0xffff9c
#define IOREG_BRA4H		0xffff9c
#define IOREG_BRA4L		0xffff9d
#define IOREG_BRB4		0xffff9e
#define IOREG_BRB4H		0xffff9e
#define IOREG_BRB4L		0xffff9f

/*	Control bit in TSTR by mask	*/

#define TSTR_STR4		0x10
#define TSTR_STR3		0x08
#define TSTR_STR2		0x04
#define TSTR_STR1		0x02
#define TSTR_STR0		0x01

/*	Control bit in TSTR by bit offset	*/

#define TSTR_BIT_STR4		4
#define TSTR_BIT_STR3		3
#define TSTR_BIT_STR2		2
#define TSTR_BIT_STR1		1
#define TSTR_BIT_STR0		0

/*	Control bit in TSNC		*/

#define TSNC_SYNC4		0x10
#define TSNC_SYNC3		0x08
#define TSNC_SYNC2		0x04
#define TSNC_SYNC1		0x02
#define TSNC_SYNC0		0x01

/*	Control bit in TMDR		*/

#define TMDR_MDF		0x40
#define TMDR_FDIR		0x20
#define TMDR_PWM4		0x10
#define TMDR_PWM3		0x08
#define TMDR_PWM2		0x04
#define TMDR_PWM1		0x02
#define TMDR_PWM0		0x01

/*	Control bit in TFCR		*/

#define TFCR_CMD1		0x20
#define TFCR_CMD2		0x10
#define TFCR_BFB4		0x08
#define TFCR_BFA4		0x04
#define TFCR_BFB3		0x02
#define TFCR_BFA3		0x01

/*	Control bit in TCR		*/

#define TCR_CCLR1		0x40
#define TCR_CCLR0		0x20
#define TCR_CKEG1		0x10
#define TCR_CKEG0		0x08
#define TCR_TPSC2		0x04
#define TCR_TPSC1		0x02
#define TCR_TPSC0		0x01

/*	Control bit in TIOR		*/

#define TIOR_IOB2		0x40
#define TIOR_IOB1		0x20
#define TIOR_IOB0		0x10
#define TIOR_IOA2		0x04
#define TIOR_IOA1		0x02
#define TIOR_IOA0		0x01

/*	Control bit in TIER		*/

#define TIER_OVIE		0x04
#define TIER_IMIEB		0x02
#define TIER_IMIEA		0x01

/*	Control bit in TSR by mask	*/

#define TSR_OVF			0x04
#define TSR_IMFB		0x02
#define TSR_IMFA		0x01

/*	Control bit in TSR by bit offset	*/

#define TSR_BIT_OVF		2
#define TSR_BIT_IMFB		1
#define TSR_BIT_IMFA		0

/*	Memory Address		*/

#define PADDR_A23		0x10
#define PADDR_A22		0x20
#define PADDR_A21		0x40
#define PADDR_A20		0x80

#define P5DDR_A19		0x08
#define P5DDR_A18		0x04
#define P5DDR_A17		0x02
#define P5DDR_A16		0x01

/*	Control bit in Memory Chip Select	*/

#define P8DDR_CS0		0x10
#define P8DDR_CS1		0x08
#define P8DDR_CS2		0x04
#define P8DDR_CS3		0x02
#define PADDR_CS4		0x40
#define PADDR_CS5		0x20
#define PADDR_CS6		0x10
#define PBDDR_CS7		0x20

/*	Mode Control Regisger		*/

#define IOREG_MDCR		0xfffff1

/*	Control bit in MDCR		*/

#define MDCR_MDS0		0x01
#define MDCR_MDS1		0x02
#define MDCR_MDS2		0x04
#define MDCR_MDS_MASK		0x07

/*	Bus Release Control Regisger	*/

#define IOREG_BRCR		0xfffff3

/*	Control bit in BRCR		*/

#define BRCR_BRLE		0x01
#define BRCR_A21E		0x20
#define BRCR_A22E		0x40
#define BRCR_A23E		0x80

#endif	/* of #ifndef _3052_H_ */
